import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class quiz extends Frame implements WindowListener,MouseListener, MouseMotionListener
{

	int MAXQUESTIONS=10;			//questions total
	int readLines=0;				//Lines read
	int line=0;						//current question
	int correct=0;					//# correct
	boolean [] answers = new boolean[MAXQUESTIONS];	//answers given, stores in array-1
	boolean[] realAnswers=new boolean[MAXQUESTIONS];//real answers
	String []question;				//question printed, stores in question[1], #1...
	String []answerExp;
	boolean highlight=false;		//highlight button?
	boolean drawBackground=true;	//drawbackground or not
	boolean pressed=false;			//button pressed?
	boolean highlightTrue=false;	//highlighted true
	boolean highlightFalse=false;	//highlighted false
	boolean clear=false;			//clear screen
	boolean reviewing=false;		//reviewing answers
	boolean scanning=false;			//scanning words
	int scanHighlight=-1;			//question highlighted -1
	
	public static void main(String[] args)
	{
		quiz f = new quiz();
		f.setSize(500,500);
		f.setVisible(true);
	}
	public quiz()
	{
		setLayout(new FlowLayout());
		
		
		question = new String[100];
		answerExp = new String[100];
		
		this.addWindowListener(this);
		addMouseListener(this);
		addMouseMotionListener(this);
		setTitle("1D Arays Quiz");
		
	}
	public void update(Graphics g)
	{
	

		if(clear || reviewing)
			{g.clearRect(0,0,500,500);clear=false;}
		if(drawBackground)
			{drawBackground=false;	backGround();}
		g.setFont(new Font("Arial",Font.BOLD,30));
		if(line==0)	//begin
		{
			g.setColor(Color.red);
			
			g.drawRect(119,119,261,61);
			g.setColor(Color.white);
			g.fillRect(120,120,260,60);
			g.setColor(Color.red);
			g.drawString("Begin",210,160);
			
			if(highlight)
			{
		
			
					g.setColor(Color.red);
					g.drawRect(100,100,300,100);
					g.drawRect(101,101,298,98);
					g.drawRect(102,102,296,96);
					
			
			}
			//end begin
				
		}
		g.setColor(Color.black);
		
		
		if(line>0 && line<=MAXQUESTIONS)		//=-1 if end, 0 if beginning
		{
			getQuestion(line);
			g.clearRect(0,0,500,250);
			g.drawLine(0,250,500,250);
			g.drawLine(0,251,500,251);
			
			g.drawLine(0,50,300,50);
			g.drawLine(0,53,370,53);
			g.setFont(new Font("Serif",Font.BOLD+Font.ITALIC,25));
			g.drawString("Quiz: Question "+line,50,50);
			g.setFont(new Font("Serif",Font.BOLD,20));
			
			//Draw question
			
			for(int i=0;i<readLines;i++)
			{
				g.drawString(question[i],50,90+20*i);
			}
		
			//draw true button
			g.setColor(new Color(0,150,0));
			g.fillRect(50,400,100,50);
			g.drawRect(46,396,108,58);
			
			
			//draw false button
			g.setColor(new Color(150,0,0));
			g.fillRect(350,400,100,50);
			g.drawRect(346,396,108,58);
			
			//highlight true
			if(highlightTrue)
			{
				g.setColor(new Color(0,200,0));
				g.fillRect(50,400,100,50);
				g.drawRect(46,396,108,58);
			}
			//highlight false
			if(highlightFalse)
			{
				g.setColor(new Color(200,0,0));
				g.fillRect(350,400,100,50);
				g.drawRect(346,396,108,58);
			
			}
			
			g.setFont(new Font("Arial",Font.BOLD,30));
			g.setColor(Color.white);
			g.drawString("TRUE",57,435);
			g.drawString("FALSE",352,435);
			
		}
		if(line>MAXQUESTIONS && !reviewing) {
			if(!scanning)
			{
				g.clearRect(0,0,500,500);
				backGround();
				
				g.drawString("Quiz Complete!",220,50);
				g.clearRect(100,100,300,300);
				g.drawRect(100,100,300,300);
				g.drawRect(102,102,296,296);
				getAnswers();
			
				g.setFont(new Font("Serif",Font.BOLD,14));
				correct=0;
				g.drawString("Your Answer",150,130);
				g.drawString("Real Answer",250,130);
				g.drawLine(130,132,370,132);
				for(int i=0;i<MAXQUESTIONS;i++)
				{
					g.setColor(Color.black);
					g.drawString((i+1)+".  "+answers[i],150,150+20*i);
					g.drawString(""+realAnswers[i],250,150+20*i);
					if(answers[i]==realAnswers[i])correct++;
					else{g.setColor(Color.red); g.drawLine(150,145+20*i,300,145+20*i);}
					
				}
				g.setColor(Color.black);
				g.drawLine(250,350,400,350);
				g.drawLine(250,351,400,351);
				g.drawString("Correct: "+correct,300,370);
				g.drawString("Total: "+MAXQUESTIONS,300,390);
				g.setFont(new Font("Serif",Font.BOLD+Font.ITALIC,20));
				g.setColor(Color.red);
				g.drawString("Correct:"+correct*100/MAXQUESTIONS+"%",300,70);
				
				g.setFont(new Font("Serif",Font.PLAIN,15));
				g.drawString("Click on questions for explanations.",200,490);
				scanning=true;	//don't redraw everything
			}
			else	//are scanning
			{
				for(int i=0;i<MAXQUESTIONS;i++)
				{
					g.setColor(Color.black);
					g.setFont(new Font("Serif",Font.BOLD,14));
					if(i==scanHighlight) g.setColor(Color.blue);
					g.drawString((i+1)+".  "+answers[i],150,150+20*i);
					g.drawString(""+realAnswers[i],250,150+20*i);
					if(answers[i]!=realAnswers[i])
					{g.setColor(Color.red); g.drawLine(150,145+20*i,300,145+20*i);}
					
				}
			}
			
		}
		
		if(reviewing)
		{
			
			g.drawLine(0,250,500,250);
			g.drawLine(0,251,500,251);
			
			g.drawLine(0,50,300,50);
			g.drawLine(0,53,370,53);
			g.setFont(new Font("Serif",Font.BOLD+Font.ITALIC,25));
			g.drawString("Quiz: Question "+(scanHighlight+1),50,50);
			
			g.setFont(new Font("Serif",Font.BOLD,20));
			
			//Draw question
			getQuestion(scanHighlight+1);
			for(int i=0;i<readLines;i++)
			{
				g.drawString(question[i],50,90+20*i);
			}
			
			//draw Answer
			getExplanation(scanHighlight+1);
			for(int i=0;i<readLines;i++)
			{
				g.drawString(answerExp[i],50,270+20*i);
			}
			g.setFont(new Font("Serif",Font.PLAIN,15));
			g.drawString("Click to return",300,490);
		}
	}
	public void getAnswers()
	{
		int i=0;
	
		String text="";
		try{
			BufferedReader inFile = new BufferedReader(new FileReader("answers.txt"));
			while((text=inFile.readLine())!=null)
			{
				if(text.compareTo(String.valueOf(i+1))==0) 
				{
					if((text=inFile.readLine())!=null)
					{
						if(text.compareTo("true")==0)
							realAnswers[i]=true;
						else realAnswers[i]=false;
						i++;
					}
				}
			}
		inFile.close();
		}
		catch(IOException e){}
		
	}
	public void getExplanation(int number)
	{
		boolean go=false;	//begin recording
		String text="";
		readLines=0;
		
		try
		{
			BufferedReader inFile = new BufferedReader(new FileReader("answers.txt"));
	
	
			while((text=inFile.readLine())!=null && text.compareTo(String.valueOf(number+1))!=0)
			{
				answerExp[readLines]=text;
				if(go)
				{	readLines++;}
				
				if(text.compareTo(String.valueOf(number))==0)go=true;
			}
			inFile.close();
		}
		catch(IOException e){}
	}
	public void getQuestion(int number)
	{
		boolean go=false;	//begin recording
		String text="";
		readLines=0;
		
		try
		{
			BufferedReader inFile = new BufferedReader(new FileReader("questions.txt"));
	
	
			while((text=inFile.readLine())!=null && text.compareTo(String.valueOf(number+1))!=0)
			{
				question[readLines]=text;
				if(go)
				{	readLines++;}
				
				if(text.compareTo(String.valueOf(number))==0)go=true;
			}
			inFile.close();
		}
		catch(IOException e){}
		
	}
	public void backGround()
	{
		Graphics g= getGraphics();
		g.setFont(new Font("Serif",Font.BOLD,100));

		g.setColor(new Color(200,200,200));
		g.drawString("A R R A Y",20,280);
		g.setFont(new Font("Serif",Font.BOLD+Font.ITALIC,30));
		g.drawString("Q U I Z",330,450);
		
		for(int i=0;i<25;i++)
		{
			g.setColor(new Color(i*10,i*10,i*10));
					
			g.drawOval(100+3*i,100+3*i,500-6*i,500-6*i);
			g.drawOval(130,i*20,20,20);
			g.drawOval(130+2,i*20+2,16,16);
		}
					
		g.setColor(Color.gray);
		for(int i=0;i<8;i++)
		{
			g.drawRect(50+50*i,300,40,40);
			g.drawRect(51+50*i,301,38,38);
			g.drawRect(52+50*i,302,36,36);
			if(i!=7)
			g.fillRect(90+50*i,319,10,2);
						
			g.setFont(new Font("serif",Font.BOLD+Font.ITALIC,24));
			g.drawString(""+i,50*i+53,325);
		}
	}
	public void mousePressed(MouseEvent e)
	{
		pressed=true;
		
		repaint();
	}
	public void mouseReleased(MouseEvent e)
	{
		if(reviewing)
		{
			reviewing=false;
			scanning=false;
		}
		if(scanning && scanHighlight!=-1)
		{
			reviewing=true;
		}
		
	
		if(line==0 && highlight)
		{
			line=1;
			
		}
		if(line>0 && highlightTrue)
		{
			if(line<=MAXQUESTIONS)
			{
				answers[line-1]=true;
				line++; 
			}
		}
		if(line>0 && highlightFalse)
		{
			if(line<=MAXQUESTIONS)
			{
				answers[line-1]=false;
				line++;
			}
		}
		repaint();
	}
	public void mouseEntered(MouseEvent e){}
	public void mouseExited(MouseEvent e){}
	public void mouseDragged(MouseEvent e){}
	public void mouseMoved(MouseEvent e)
	{

		if(line>MAXQUESTIONS && !reviewing)
		{
			drawBackground=false;
			clear=false;
			

			scanHighlight=-1;
			if(e.getX()>150 && e.getX()<320)
			{
				for(int i=0;i<MAXQUESTIONS;i++)
				{
					if(e.getY()>130+20*i && e.getY()<150+20*i) {scanHighlight=i;}
					
				}
			}
			repaint();
			
		}
		if(line<=MAXQUESTIONS)
		{
			if(line==0)
			{
				
				
				if(highlight==false && (e.getX()>120 && e.getX()<380 && e.getY()>120 && e.getY()<180))
					{drawBackground=true;clear=true;highlight=true;repaint();}
				if(highlight==true && (e.getX()<=120 || e.getX()>=380 || e.getY()<=120 || e.getY()>=180))
					{drawBackground=true;clear=true;highlight=false;repaint();}
			}
			if(line>0)
			{
				if(e.getX()>50 && e.getX()<150 && e.getY()>400 && e.getY()<450)
				{
					if(!highlightTrue)
					{highlightTrue=true;repaint();}
				}
				else
				{
					if(highlightTrue)
					{highlightTrue=false;repaint();}
				}
				if(e.getX()>350 && e.getX()<450 && e.getY()>400 && e.getY()<450)
				{
					if(!highlightFalse)
					{highlightFalse=true;repaint();}
				}
				else
				{
					if(highlightFalse)
					{highlightFalse=false;repaint();}
				}
				
			}
		}
		
		
		
	}
	public void mouseClicked(MouseEvent e){}
	
	
	
	public void windowClosing(WindowEvent e){this.setVisible(false);}
	public void windowClosed(WindowEvent e){}
	public void windowOpened(WindowEvent e){}
	public void windowIconified(WindowEvent e){}
	public void windowDeiconified(WindowEvent e){}
	public void windowActivated(WindowEvent e){scanning=false;if(!reviewing)drawBackground=true;repaint();}
	public void windowDeactivated(WindowEvent e){}
	
}
